"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("util");
/**
 * Clase base para los Worker y Fork
 */
class Base {
    /**
     * Contructor de la clase
     * @param conf Configuracion del servicio
     */
    constructor(conf, topic) {
        /**
         * Topico del servicio
         * @protected
         */
        this.Topic = '';
        this.config = conf;
        this.Topic = topic;
    }
    /**
     * Metodo que hace rel registro de Forks
     * para su utilizacion sobre los servicios.
     * @param conf Configuracion para el evento
     */
    forksConfig(conf) {
        return;
    }
    transformFilters(filters) {
        if (util_1.isNull(filters)) {
            return filters;
        }
        else if (util_1.isObject(filters)) {
            const r = {};
            // tslint:disable-next-line: forin
            for (const k in filters) {
                let val = null;
                if (util_1.isArray(filters[k])) {
                    val = filters[k][0];
                }
                else {
                    val = filters[k];
                }
                r[k] = val;
            }
            return r;
        }
    }
    /**
     * Metodo para dar formato a los mensajes de salida.
     * @param data Datos a enviar
     * @param arg Argumentos extra
     */
    formatResponse(Data, ...arg) {
        // Variable para conocer si es un error o no
        let isError = false;
        // Validar si es un error
        if (arg[1] < 0) {
            isError = true;
        }
        // Objecto base de respuesta
        const response = {
            data: Data.data,
            headers: Data.headers,
            metadata: Data.metadata,
            response: {
                data: {
                    response: arg[0],
                },
                meta: {
                    id_transaction: Data.metadata.id_transaction,
                    status: isError ? 'ERROR' : 'SUCCESS',
                },
            },
            uuid: Data.uuid,
        };
        // Regresar todo
        return {
            errorCode: arg[1],
            response,
        };
    }
}
exports.default = Base;
